#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1400four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1400four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four14004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four14004xi = {
                1:'1017x-248y929z',
                2:'1036x-568y750z',
                3:'1036x-933y121z',
                4:'1037x-196y918z',
                5:'1055x-142y908z',
                6:'1070x-88y897z',
                7:'1071x-516y738z',
                8:'1082x-32y886z',
                9:'1084x-878y107z',
                10:'1103x-462y726z',
                11:'1130x-821y94z',
                12:'113x-69y1393z',
                13:'114x-275y1367z',
                14:'1172x-761y80z',
                15:'1211x-699y66z',
                16:'1213x-435y765z',
                17:'1246x-635y52z',
                18:'1278x-569y38z',
                19:'128x-69y1392z',
                20:'1306x-501y24z',
                21:'1331x-432y10z',
                22:'134x-281y1364z',
                23:'142x-1356y315z',
                24:'144x-68y1390z',
                25:'155x-286y1361z',
                26:'161x-66y1389z',
                27:'177x-289y1358z',
                28:'177x-62y1387z',
                29:'193x-57y1385z',
                30:'199x-290y1354z',
                31:'210x-50y1383z',
                32:'213x-1350y301z',
                33:'222x-290y1351z',
                34:'225x-41y1381z',
                35:'229x-557y1263z',
                36:'241x-31y1378z',
                37:'246x-289y1347z',
                38:'256x-19y1376z',
                39:'263x-555y1257z',
                40:'270x-285y1343z',
                41:'270x-6y1373z',
                42:'284x-1340y288z',
                43:'294x-280y1339z',
                44:'298x-552y1251z',
                45:'319x-273y1335z',
                46:'333x-546y1245z',
                47:'343x-264y1331z',
                48:'355x-1326y274z',
                49:'368x-253y1326z',
                50:'368x-538y1238z',
                51:'373x-790y1093z',
                52:'392x-240y1322z',
                53:'403x-528y1232z',
                54:'415x-225y1317z',
                55:'419x-779y1084z',
                56:'425x-1308y260z',
                57:'438x-209y1312z',
                58:'438x-515y1225z',
                59:'461x-191y1307z',
                60:'465x-765y1075z',
                61:'473x-501y1218z',
                62:'483x-171y1302z',
                63:'493x-1286y246z',
                64:'503x-149y1297z',
                65:'507x-484y1211z',
                66:'511x-749y1066z',
                67:'516x-962y875z',
                68:'523x-125y1292z',
                69:'541x-464y1204z',
                70:'542x-100y1286z',
                71:'556x-730y1057z',
                72:'559x-73y1281z',
                73:'561x-1261y232z',
                74:'571x-941y864z',
                75:'574x-443y1197z',
                76:'575x-45y1275z',
                77:'589x-15y1269z',
                78:'600x-707y1048z',
                79:'606x-419y1189z',
                80:'624x-917y853z',
                81:'627x-1232y219z',
                82:'638x-392y1182z',
                83:'643x-683y1038z',
                84:'668x-364y1174z',
                85:'676x-889y842z',
                86:'686x-655y1029z',
                87:'692x-1199y205z',
                88:'696x-334y1167z',
                89:'71x-1358y328z',
                90:'724x-301y1159z',
                91:'727x-625y1019z',
                92:'727x-859y831z',
                93:'749x-267y1151z',
                94:'755x-1163y191z',
                95:'766x-592y1010z',
                96:'773x-231y1143z',
                97:'777x-826y820z',
                98:'795x-192y1135z',
                99:'805x-557y1000z',
                100:'816x-1123y177z',
                101:'816x-153y1127z',
                102:'825x-790y808z',
                103:'834x-111y1118z',
                104:'83x-63y1396z',
                105:'841x-519y990z',
                106:'849x-68y1110z',
                107:'863x-24y1101z',
                108:'871x-751y797z',
                109:'875x-1080y163z',
                110:'876x-479y980z',
                111:'909x-437y970z',
                112:'916x-709y785z',
                113:'931x-1034y149z',
                114:'939x-393y960z',
                115:'94x-268y1370z',
                116:'958x-664y774z',
                117:'968x-346y950z',
                118:'97x-67y1394z',
                119:'985x-985y135z',
                120:'993x-298y939z',
                121:'998x-617y762z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1400four4xi" usage = "target function for charge14004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1400four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1400FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1400FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1400FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1400FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1400FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four14004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1400FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1400FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1400FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four14004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four14004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1400FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1400FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1400FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1400four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    